program AUC;

uses crt,dos,graph;

{$M 65000,0,655360}

const BauTypMax=6;
      TruppTypMax=13;
      HandkTypMax=36;
      Path='c:\Joerg\pascal\auc\dat\';
      MaxFeldx=43;
      MaxFeldy=25;

type
  str255=string[255];
  str20=string[15];
  str12=string[12];
  str8=string[8];
  DingZeiger=^Dinge;
  StrZeiger=^Strlsttyp;
  strlsttyp=record
              nam:str8;
              nxt:StrZeiger;
            end;
  StrZeigerZeiger=^StrZeigerListTyp;
  StrZeigerListTyp=record
                     nxt:StrZeigerZeiger;
                     lst:StrZeiger;
                   end;
  DinglistZeiger=^Dinglist;
  DingList=record
             Ding:DingZeiger;
             nxt:DinglistZeiger;
           end;
Dingerec=record   {Ein Programmiertrick zum speichern}
          ortx,orty      :byte; 
          typ            :integer;
          ID             :String;
          anzahl         :integer;
          Wert           :integer;
          Besitz         :byte;
          Name           :string[20];
        end;
  Dinge=record
          ortx,orty      :byte; {Kartenposition}
          typ            :integer; {Gibt die Ausrichtung der Aubauten (zB.Strae) an}
          inv            :DingListZeiger;
          env            :DingZeiger;
          ID             :StrZeiger;
          anzahl         :integer; {Bevlkerung, Armeestrke,...}
          Wert           :integer; {K*1,K*2,...}
          Besitz         :byte;
          Name           :str20;
        end;
ZugListZeiger=^Zuglisttyp;
Zuglisttyp=record
             name:str20;
             befehle:StrZeiger;
             nxt:ZugListZeiger;
           end;
SpielerlistZeiger=^Spielerlisttyp;
FeldTyp=array[1..MaxFeldx,1..MaxFeldy] of DingZeiger;
Spielerlisttyp=record
                 name:str20;
                 nxt:SpielerlistZeiger;
                 reich:str20;
                 feld:Feldtyp;
               end;
Spielerladetyp=record
                 name:string[20];
                 Zugliste:ZuglistZeiger;
                 nxt:SpielerlistZeiger;
                 reich:string[20];
               end;

var
 feld                  :FeldTyp;
 c                     :char;
 Nullobjekt            :Dingzeiger;
 Spielerliste,Spieler  :SpielerListZeiger;
 SpielerAn             :boolean;
 f                     :text;
 GlobalID              :StrZeigerZeiger;

function MakeIDList(s:string):strZeiger;
var p,Liste:StrZeiger;
    id:string;
    a:integer;
begin
  a:=1;p:=nil;Liste:=nil;
  while a<length(s) do
    begin
      id:='';
      while s[a]<>'|' do
        begin
          id:=id+s[a];
          a:=a+1;
        end;
      a:=a+1;
      if Liste=nil then begin New(Liste);p:=liste;end
                   else begin New(p^.nxt);p:=p^.nxt;end;
      p^.nxt:=nil;
      p^.nam:=id;
    end;
  MakeIDList:=Liste;
end;

function IDString(lst:StrZeiger):string;
var p:StrZeiger;
    s:string;
begin
  p:=lst;s:='';
  while p<>nil do
    begin
      s:=s+p^.nam+'|';
      p:=p^.nxt;
    end;
  IDString:=s;
end;

procedure AddID(var ding:dingzeiger;s:string);
var q:StrZeigerZeiger;
    t:string;
    s1:str8;
begin
  s1:=s;
  t:=IDString(ding^.ID)+s1+'|';q:=GlobalID;
  while (q<>nil) and (t<>IDString(q^.lst))
    do q:=q^.nxt;
  if q=nil
    then
      begin
        if GlobalID=nil
          then
            begin
              new(globalID);q:=globalID;
            end
          else
            begin
              q:=globalID;while q^.nxt<>nil do q:=q^.nxt;
              new(q^.nxt);q:=q^.nxt;
            end;
        q^.nxt:=nil;
        q^.lst:=MakeIDList(t);
        ding^.id:=q^.lst;
      end
    else
      ding^.id:=q^.lst;
end;

function IsID(ding:dingzeiger;s:string):boolean;
var p:StrZeiger;
    f:boolean;
    b:byte;
begin
  p:=ding^.ID;f:=FALSE;b:=0;
  if length(s)>8 then s:=copy(s,1,8);
  while (p<>nil) and (not f) and (b<10) do
    begin
      if p^.nam=s then f:=TRUE;
      p:=p^.nxt;b:=b+1;
    end;
  IsID:=f;
end;

function IsGetarnt(ding:dingzeiger):dingzeiger;
 {Nil=Nicht getarnt, sonst wird Tarnung bergeben}
var p:dinglistzeiger;
    q:dingzeiger;
begin
  p:=ding^.inv;
  q:=ding;
  while p<>nil do
    begin
      if IsID(p^.ding,'Tarnung') then q:=p^.ding;
      p:=p^.nxt;
    end;
  IsGetarnt:=q;
end;



function GetID(ding:dingzeiger;nr:integer):str8;
var p:StrZeiger;
    s:string;
    a:integer;
begin
  p:=ding^.ID;s:='';a:=nr-1;
  while (p<>nil) and (a>0) do
    begin
      p:=p^.nxt;
      a:=a-1;
    end;
  if p<>nil then s:=p^.nam;
  GetID:=s;
end;

procedure SubINV(env,Ding:Dingzeiger);
var p,q:DingListZeiger;
begin
  p:=env^.INV;q:=nil;
  while (p<>nil) do
    begin
      if p^.Ding=Ding then
        begin
          if p=env^.INV
           then
             begin
{               q:=inv^.nxt;
               dispose(INV);
               INV:=q; Hier funkt was nicht. Daher Speicherverschwendung }
               env^.INV:=env^.INV^.nxt;
             end
           else
             begin
               q^.nxt:=p^.nxt;
               dispose(p);
               p:=q^.nxt;
             end;
        end;
      if p<>nil then
        begin
          q:=p;p:=p^.nxt;
        end;
    end;
end;

procedure AddINV(env,ding:Dingzeiger);
var p:DingListZeiger;
begin
  SubINV(env,ding); {Verhindert, da ein Objekt 2x vorkommt in einem Inventory}
  p:=env^.INV;
  if p=nil
    then
      begin
        new(env^.INV);env^.INV^.Ding:=ding;env^.INV^.nxt:=nil;
      end
    else
      begin
        while p^.nxt<> nil do p:=p^.nxt;
        new(p^.nxt);p:=p^.nxt;
        p^.Ding:=Ding;p^.nxt:=nil;
      end;
end;

procedure DingInit(ding:dingzeiger);
begin
  Ding^.ortx:=0;Ding^.orty:=0;
  Ding^.typ:=0;
  Ding^.inv:=nil;
  Ding^.ID:=nil;
  Ding^.anzahl:=0;
  Ding^.Wert:=0;
  Ding^.Besitz:=0;
  Ding^.env:=nil;
  Ding^.Name:='unbenannt';
end;

procedure DingDone(ding:dingzeiger);
var p,q:DinglistZeiger;
    a,b:StrZeiger;
begin
  p:=Ding^.INV;
  while (p<>nil) do
   begin
     q:=p;p:=p^.nxt;
     SubINV(ding,q^.Ding);{Befreit den Speicherplatz fr das Inventory}
     DingDone(q^.ding);
     dispose(q^.Ding); {Unterobjekte werden rekursiv mitzerstrt.}
   end;
end;


function Reichsname(nr:integer):str20;
var p:spielerlistzeiger;
    a:integer;
    s:str20;
begin
  p:=spielerliste;
  a:=nr-1;
  while (p<>nil) and (a>0)
   do
    begin
      a:=a-1;p:=p^.nxt;
    end;
  if p<>nil then s:=p^.reich
            else str(nr,s);
  if nr=0 then s:='herrenlos';
  Reichsname:=s;
end;

function Spielerzeiger(nr:integer):SpielerListZeiger;
var p:spielerlistzeiger;
    a:integer;
    s:str20;
begin
  p:=spielerliste;
  a:=nr-1;
  while (p<>nil) and (a>0)
   do
    begin
      a:=a-1;p:=p^.nxt;
    end;
  if p<>nil then SpielerZeiger:=p
            else SpielerZeiger:=spielerliste;
end;

function SpielerAnzahl:integer;
var a:integer;
    p:SpielerListZeiger;
begin
  p:=SpielerListe;a:=0;
  while p<>nil do
    begin
      p:=p^.nxt;
      a:=a+1;
    end;
  Spieleranzahl:=a;
end;

function JaNein:boolean;
var c:char;
begin
  repeat
    c:=upcase(readkey);
  until (c='J') or (c='N') or (c=chr(13));
  if c='J' then JaNein:=true
           else JaNein:=false;
end;

procedure PlusMinus(var a:integer);
var ende:boolean;
    x,y:byte;
    e:char;
begin
  x:=wherex;y:=wherey;
  repeat
    e:=readkey;
    case e of
      '+' : if a<32767 then a:=a+1;
      '-' : if a>0 then a:=a-1;
    end;
    if (e='+') or (e='-') then
      begin
        gotoxy(x,y);write(a,' ',chr(8));
      end;
  until e=chr(13);
end;

procedure ReadnrXY(x,y:integer;var nr:integer);
const ziffer=['0'..'9'];
var e:char;
    s:string[5];
    code:integer;
begin
  s:='';nr:=0;
  setcolor(15);
  repeat
    e:=readkey;
    if (e in ziffer) and (length(s)<5) then
      begin
        outtextXY(x+length(s)*10,y,e);
        s:=s+e;
      end;
    if (e=chr(8)) and (length(s)>0) then
      begin
        setcolor(0);
        outtextXY(x+(length(s)-1)*10,y,s[length(s)]);
        setcolor(15);
        delete(s,length(s),1);
      end;
  until (e=chr(13)) or (e=chr(27));
  val(s,nr,code);
  if e=chr(27) then nr:=0;
  if code<>0 then nr:=0;
end;

procedure ReadStrXY(x,y:integer;var StrOut:str20);
const ziffer=['0'..'9'];
      Buchstabe=['a'..'z','A'..'Z',' ','-','"','&','','','','','','',''];
var e:char;
    s:string[20];
    code:integer;
begin
  s:='';
  setcolor(15);
  repeat
    e:=readkey;
    if ((e in ziffer) or (e in Buchstabe)) and (length(s)<20) then
      begin
        outtextXY(x+length(s)*10,y,e);
        s:=s+e;
      end;
    if (e=chr(8)) and (length(s)>0) then
      begin
        setcolor(0);
        outtextXY(x+(length(s)-1)*10,y,s[length(s)]);
        setcolor(15);
        delete(s,length(s),1);
      end;
  until (e=chr(13)) or (e=chr(27));
  if e<>chr(27) then StrOut:=s;
end;

procedure pressreturn;
var a:char;
begin
  repeat
   a:=readkey;
  until (a=chr(13)) or (a=chr(27));
end;

procedure initgrafik;
var grtrb,grmode:integer;
begin
  grtrb:=detect;
  initgraph(grtrb,grmode,'');
end;

function Notation(x,y:integer):string;
var s:string[6];
begin
  str(y,s);
  if x>26 then Notation:=chr(64+x-26)+chr(64+x-26)+s
          else Notation:=chr(64+x)+s;
end;

function xNachbar(feldx,feldy,richtung:byte):byte;
var a:byte;
begin
  a:=0;
  case richtung of
    1,4 : a:=feldx;
    2,3 : if feldx>=MaxFeldx then a:=0 else a:=feldx+1;
    5,6 : if feldx<=1 then a:=0 else a:=feldx-1;
  end;
  xNachbar:=a;
end;

function yNachbar(feldx,feldy,richtung:byte):byte;
var a:byte;
begin
  a:=0;
  case richtung of
    1 : if feldy<=1 then a:=0 else a:=feldy-1;
    4 : if feldy>=MaxFeldy then a:=0 else a:=feldy+1;
    2,6 : if (feldx mod 2)=0
            then a:=feldy
            else if feldy<=1 then a:=0 else a:=feldy-1;
    5,3 : if (feldx mod 2)=0
            then if feldy>=MaxFeldy then a:=0 else a:=feldy+1
            else a:=feldy;
  end;
  yNachbar:=a;
end;

procedure Grafausgabe(y:integer;str:string);
var a:integer;
begin
  setcolor(0);
  for a:=0 to 10 do
   line(0,getmaxY-115+a+y*15,getmaxX,getmaxY-115+a+y*15);
  setcolor(15);
  outtextXY(5,getmaxY-115+y*15,str);
end;

procedure ClearGraf;
var a:byte;
begin
  for a:=1 to 8 do GrafAusgabe(a,'');
end;

procedure CopyDing(org,cop,env:dingzeiger;tiefe:byte);

procedure CopyInv(org,cop,env:dingzeiger;tiefe:byte);
var p,q:dinglistzeiger;
    ding:dingzeiger;
begin
  p:=org^.INV;
  while p<>nil do
   if ((not IsID(p^.ding,'Person')) or
       (Reichsname(p^.ding^.besitz)=spieler^.reich)
      ) and (not (tiefe<=0))
     then
       begin
         ding:=nil;
         new(ding);
         DingInit(ding);
         copyDing(p^.ding,ding,env,tiefe);
         AddINV(cop,ding);
         p:=p^.nxt;
       end
     else p:=p^.nxt;
end;

var p:dingzeiger;
begin
  cop^.ortx:=org^.ortx;
  cop^.orty:=org^.orty;
  cop^.typ:=org^.typ;
  cop^.inv:=nil;
  cop^.env:=env;
  cop^.ID:=org^.ID;
  cop^.anzahl:=org^.anzahl;
  if reichsname(org^.besitz)=spieler^.reich
    then cop^.Wert:=org^.wert
    else cop^.wert:=0;
  cop^.Besitz:=org^.Besitz;
  cop^.Name:=org^.Name;
  CopyINV(org,cop,cop,tiefe-1);
end;

procedure CopyAlles(org,cop,env:dingzeiger);

procedure CopyInv(org,cop,env:dingzeiger);
var p,q:dinglistzeiger;
    ding:dingzeiger;
begin
  p:=org^.INV;
  while p<>nil do
       begin
         ding:=nil;
         new(ding);
         DingInit(ding);
         copyAlles(p^.ding,ding,env);
         AddINV(cop,ding);
         p:=p^.nxt;
       end
end;

var p:dingzeiger;
begin
  cop^.ortx:=org^.ortx;
  cop^.orty:=org^.orty;
  cop^.typ:=org^.typ;
  cop^.inv:=nil;
  cop^.env:=env;
  cop^.ID:=org^.ID;
  cop^.anzahl:=org^.anzahl;
  cop^.Besitz:=org^.Besitz;
  cop^.Name:=org^.Name;
  cop^.wert:=org^.wert;
  CopyINV(org,cop,cop);
end;

procedure FeldReset(var feld:feldtyp);
var a,b:integer;
begin
  for a:=1 to MaxFeldx do
    for b:=1 to MaxFeldy do
      begin
        new(feld[a,b]);
        Dinginit(feld[a,b]);
        feld[a,b]^.typ:=0;
        AddID(feld[a,b],'Feld');
        Feld[a,b]^.ortx:=a;
        Feld[a,b]^.orty:=b;
      end;
end;

procedure SpielerSpeichern;
var p:spielerlistzeiger;
    q:spielerladetyp;
    f:file of spielerladetyp;
begin
  assign(f,path+'AUCSpiel.dat');
  rewrite(f);
  p:=spielerliste;
  while p<>nil do
    begin
      q.reich:=p^.reich;
      q.zugliste:=nil;
      q.name:=p^.name;
      q.nxt:=nil;
      write(f,q);
      p:=p^.nxt;
    end;
  close(f);
end;

procedure SpielerLaden;
var p:spielerlistzeiger;
    t:spielerladetyp;
    f:file of spielerladetyp;
begin
  assign(f,path+'AUCSpiel.dat');
  reset(f);
  spielerliste:=nil;
  while not eof(f) do
    begin
      if spielerliste=nil
        then
          begin
            new(spielerliste);
            p:=spielerliste;
          end
        else
          begin
            new(p^.nxt);
            p:=p^.nxt;
          end;
      read(f,t);
      p^.name:=t.name;
      p^.reich:=t.reich;
      p^.nxt:=nil;
      p^.feld[1,1]:=nil;
    end;
  close(f);
end;

procedure Objektespeichern(Filename:string;feld:feldtyp);
var f: file of Dingerec;
    x,y:integer;
    ding:dingerec;
    p:DingZeiger;

procedure MakeRecord(p:DingZeiger;var ding:Dingerec);
begin
  Ding.ortx:=p^.ortx;Ding.orty:=p^.orty;
  Ding.typ:=p^.typ;
  Ding.ID:=IDString(p^.ID);
  Ding.anzahl:=p^.anzahl;
  Ding.Wert:=p^.Wert;
  Ding.Besitz:=p^.Besitz;
  Ding.Name:=p^.Name;
end;

procedure SpeicherINV(env:DingZeiger);
var    p:DingListzeiger;
    ding:dingerec;
begin
  p:=env^.INV;
  while p<>nil do
    begin
      MakeRecord(p^.ding,ding);
      write(f,ding);
      SpeicherINV(p^.ding);
      p:=p^.nxt;
    end;
  MakeRecord(NullObjekt,ding);
  write(f,ding);
end;

begin
  assign(f,Path+filename+'.dat');
  rewrite(f);
  for x:=1 to MaxFeldx do
    for y:=1 to MaxFeldy do
       begin
          MakeRecord(feld[x,y],ding);
          write(f,ding);
          SpeicherINV(feld[x,y]);
       end;
  close(f);
end;

procedure ObjekteLaden(filename:string;feld:feldtyp);
var f: file of Dingerec;
    x,y:integer;
    ding:dingerec;
    p:DingZeiger;

procedure MakeDing(var p:DingZeiger;ding:Dingerec);
var a    :byte;
    s,id :string;
begin
  New(p);
  Dinginit(p);
  p^.ortx:=Ding.ortx;p^.orty:=Ding.orty;
  p^.typ:=Ding.typ;s:=ding.ID;a:=1;
  while a<length(s) do
    begin
      id:='';
      while s[a]<>'|' do
        begin
          id:=id+s[a];
          a:=a+1;
        end;
      a:=a+1;
      AddID(p,id);
    end;
  if ding.ID<>IDString(p^.id) then write(chr(7));
  p^.INV:=nil;
  p^.anzahl:=ding.anzahl;
  p^.Wert:=Ding.Wert;
  p^.Besitz:=ding.Besitz;
  p^.Name:=Ding.Name;
  p^.env:=nil;
end;

procedure LadeINV(env:DingZeiger);
var    p:DingListzeiger;
    ding:dingerec;
begin
  env^.INV:=nil;p:=nil;
  repeat
    read(f,ding);
    if Ding.name<>'0Objekt' then
      begin
        if env^.inv=nil
          then
            begin
              new(env^.inv);p:=env^.INV;
            end
          else
            begin
              new(p^.nxt);p:=p^.nxt;
            end;
          p^.nxt:=nil;p^.ding:=nil;
          MakeDing(p^.ding,ding);
          p^.ding^.env:=env;
          LadeINV(p^.ding);
      end;
  until Ding.name='0Objekt';
end;

begin
  p:=nil;
  assign(f,Path+filename+'.dat');
  reset(f);
  for x:=1 to MaxFeldx do
    for y:=1 to MaxFeldy do
       begin
         read(f,ding);
         DingDone(feld[x,y]);
         dispose(feld[x,y]);
         MakeDing(p,ding);
         feld[x,y]:=p;
         LadeINV(feld[x,y]);
       end;
  close(f);
end;

function TerrainName(a:byte):string;
var s:string;
begin
  case a of
    0:s:='Terra Inkognita';
    1:s:='Wasser';
    2:s:='Tiefland';
    3:s:='Tiefland-Wald';
    4:s:='Tiefland-Sumpf';
    5:s:='Tiefland-Wste';
    6:s:='Hochland';
    7:s:='Hochland-Wald';
    8:s:='Hochland-Sumpf';
    9:s:='Hochland-Wste';
   10:s:='Bergland';
   11:s:='Bergland-Wald';
   12:s:='Bergland-Wste';
   13:s:='Gebirge';
   14:s:='Gebirge-Wald';
   15:s:='Gebirge-Wste';
  end;
  TerrainName:=s;
end;

function MaxTerrainBev(a:byte):integer;
var s:integer;
begin
  s:=0;
  case a of
    0:s:=0;
    1:s:=0;
    2:s:=8000;
    3:s:=5000;
    4:s:=2000;
    5:s:=2000;
    6:s:=5000;
    7:s:=3000;
    8:s:=1000;
    9:s:=1000;
   10:s:=3000;
   11:s:=1500;
   12:s:=800;
   13:s:=2000;
   14:s:=1000;
   15:s:=400;
  end;
  MaxTerrainBev:=s;
end;

function Stufe(a:byte):byte;
var s:byte;
begin
  case a of
    0,1:s:=0;
    2,3,4,5:s:=1;
    6,7,8,9:s:=2;
   10,11,12:s:=3;
   13,14,15:s:=4;
  end;
  Stufe:=s;
end;

function BautypName(a:byte):string;
var s:string;
begin
  case a of
    1:s:='Hauptstadt';
    2:s:='Stadt';
    3:s:='Dorf';
    4:s:='Burg';
    5:s:='Dipi-Schule';
    6:s:='Forschungsinstitut';
  end;
  BauTypName:=s;
end;

function TruppTypName(a:byte):string;
var s:string;
begin
  case a of
    1:s:='Herrscher';
    2:s:='Krieger';
    3:s:='Reiter';
    4:s:='Schiffe';
    5:s:='Sklaven';
    6:s:='Pferde';
    7:s:='Gefangene';
    8:s:='Siedler';
    9:s:='Heerfhrer';
   10:s:='Zauberer';
   11:s:='Spion';
   12:s:='Diplomat';
   13:s:='Archeologe';
  end;
  TruppTypName:=s;
end;

function HandkTypName(a:byte):string;
var s:string;
begin
  case a of
    1:s:='Ocker';
    2:s:='Felle';
    3:s:='Baumwolle';
    4:s:='Roggen';
    5:s:='Fische';
    6:s:='Kse';
    7:s:='Krbe';
    8:s:='Schurwolle';
    9:s:='Bier';
   10:s:='Wein';
   11:s:='Weizen';
   12:s:='Kohle';
   13:s:='Mehl';
   14:s:='Leinen';
   15:s:='l';
   16:s:='Honig';
   17:s:='Wachs';
   18:s:='Leder';
   19:s:='Obst';
   20:s:='Tuch';
   21:s:='Kleidung';
   22:s:='Spiritus';
   23:s:='Zucker';
   24:s:='Tee';
   25:s:='Kunst';
   26:s:='Teppiche';
   27:s:='Salz';
   28:s:='Kaffee';
   29:s:='Spitzen';
   30:s:='Porzellan';
   31:s:='Seide';
   32:s:='Farben';
   33:s:='Instrumente';
   34:s:='Rauschgift';
   35:s:='Gewrze';
   36:s:='Schmuck';
  end;
  HandkTypName:=s;
end;

function HandkTypWert(a:byte):integer;
var b:integer;
begin
  case a of
    1,2,3,4,5,6,7:      b:=3000;
    8,9,10,11,12,13,14: b:=2700;
    15,16,17,18,19,20:  b:=2400;
    21,22,23,24,25:     b:=2100;
    26,27,28,29:        b:=1800;
    30,31,32:           b:=1500;
    33,34:              b:=1200;
    35:                 b:=900;
    36:                 b:=600;
  end;
  HandkTypWert:=b;
end;

function ffarbemitte(a:byte):byte;
var b:byte;
begin
  case a of
    0:b:=0;
    1:b:=1;
    2:b:=10;
    3,7,11,14:b:=2;
    4,8:b:=5;
    5,9,12,15:b:=14;
    6:b:=6;
   10:b:=7;
   13:b:=8;
  end;
  FFarbeMitte:=b;
end;

function ffarbeRand(a:byte):byte;
var b:byte;
begin
  case a of
   0:b:=15;
   1:b:=1;
   2:b:=10;
   3:b:=2;
   4:b:=5;
   5:b:=14;
   6,7,8,9:b:=6;
   10,11,12:b:=7;
   13,14,15:b:=8;
  end;
  FFarbeRand:=b;
end;

procedure Initialisierung;
var a,b:integer;
begin
  GlobalID:=nil;
  Spieler:=nil;
  Nullobjekt:=nil;
  SpielerListe:=nil;
  new(Nullobjekt);
  Dinginit(Nullobjekt);
  AddID(Nullobjekt,'0Objekt');
  Nullobjekt^.name:='0Objekt';
  FeldReset(feld);
end;

function GetTypName(ding:dingzeiger):str20;
var s,t:string;
    a:integer;
begin
  a:=IsGetarnt(ding)^.typ;
  if IsID(ding,'Feld') then s:=TerrainName(a);
  if IsID(ding,'Gebude') then s:=BauTypName(a);
  if IsID(ding,'Truppe') then s:=TruppTypName(a);
  if IsID(ding,'Handkart') then s:=HandkTypName(a);
  if IsID(ding,'Geld') then s:='Goldmuenzen';
  if IsID(ding,'Wahlding') then s:=GetID(IsGetarnt(ding),1);
  if IsID(ding,'Tarnung') then str(ding^.typ,s);
  t:='                    ';
  insert(s,t,1);
  GetTypName:=s;
end;

function KriegerWert(a:integer):longint;
var b:integer;
    s:longint;
begin
  s:=0;
  for b:=3 to (a+2) do s:=s+b;
  if a=0 then s:=2;
  Kriegerwert:=s;
end;

function SchiffWert(a:integer):longint;
var s:longint;
    b,k,z:integer;
begin
  b:=(a div 100);
  k:=((a div 10) mod 10);
  z:=(a mod 10);
  s:=2*b+k+z;
  if (5-b)>0 then s:=s+(5-b);
  s:=s*5;
  Schiffwert:=s;
end;

function Wert(ding:dingzeiger):longint;
var a:longint;
begin
  a:=0;
  if IsID(ding,'Truppe')
    then
      begin
        if IsID(ding,'Krieger') then a:=ding^.anzahl*KriegerWert(ding^.wert);
        if IsID(ding,'Reiter') then a:=ding^.anzahl*(2+KriegerWert(ding^.wert));
        if IsID(ding,'Heerfhr') then a:=ding^.anzahl*1000;
        if IsID(ding,'Pferde') then a:=ding^.anzahl*2;
        if IsID(ding,'Siedler') then a:=ding^.anzahl*2;
        if IsID(ding,'Gefangene') then a:=ding^.anzahl*2;
        if IsID(ding,'Sklaven') then a:=ding^.anzahl*1;
        if IsID(ding,'Diplomat') then a:=ding^.anzahl*200;
        if IsID(ding,'Schiffe') then a:=ding^.anzahl*SchiffWert(ding^.wert);
        if IsID(ding,'Pferde') then a:=ding^.anzahl*2;
        if IsID(ding,'Zauberer') then a:=ding^.anzahl*500;
        if IsID(ding,'Spion') then a:=ding^.anzahl*200;
      end;
  if IsID(ding,'Gebude')
    then
      begin
        if IsID(ding,'Dipi-Schule') then a:=ding^.anzahl*200;
        if IsID(ding,'Strae') then a:=ding^.anzahl*100;
      end;
  Wert:=a;
end;

function GetTruppenAnzINV(s:spielerlistzeiger;ID:str8;d:dinglistzeiger):longint;
var p:dinglistzeiger;
    anz:longint;
begin
  p:=d;anz:=0;
  while p<>nil do
    begin
      if Reichsname(p^.ding^.besitz)=s^.reich then
        begin
          if (ID='Feld') and
             ((IsID(p^.ding,'Dorf')) or (IsID(p^.ding,'Stadt')) or
              (IsID(p^.ding,'Hauptsta')))
            then anz:=anz+p^.ding^.anzahl;
          if (ID='Steuer') and
             ((IsID(p^.ding,'Dorf')) or (IsID(p^.ding,'Stadt')) or
              (IsID(p^.ding,'Hauptsta')))
            then anz:=anz+p^.ding^.anzahl div 10;
          if (ID='MGS') and IsID(p^.ding,'Truppe') and
             (not IsID(p^.ding,'Schiffe'))
            then
              anz:=anz+p^.ding^.wert*p^.ding^.anzahl;
          if (ID='Rstwert') then anz:=anz+Wert(p^.ding);
        end;
      If (IsID(p^.ding,ID)) and (Reichsname(p^.ding^.besitz)=s^.reich)
        then
          begin
            if (ID='Stadt') or (ID='Hauptsta') or (ID='Dorf')
              then anz:=anz+1
              else anz:=anz+p^.ding^.anzahl;
          end;
      anz:=anz+GetTruppenAnzINV(s,ID,p^.ding^.INV);
      p:=p^.nxt;
    end;
  GetTruppenAnzINV:=anz;
end;

function GetTruppenAnz(s:spielerlistzeiger;ID:str8):longint;
var x,y:integer;
    anz:longint;
begin
  anz:=0;
  for x:=1 to MaxFeldX do
    for y:=1 to MaxFeldY do
      begin
        If (ID='Feld') and (Reichsname(feld[x,y]^.besitz)=s^.Reich)
          then anz:=anz+feld[x,y]^.Anzahl;
          if (ID='Steuer') and (Reichsname(feld[x,y]^.besitz)=s^.Reich)
            then anz:=anz+feld[x,y]^.anzahl div 20;
          if (ID='Kleinfel') and (Reichsname(feld[x,y]^.besitz)=s^.Reich)
            then anz:=anz+1;
        anz:=anz+GetTruppenAnzINV(s,ID,feld[x,y]^.INV);
      end;
  GetTruppenAnz:=anz;
end;

procedure SpielerStatistik(s:spielerlistzeiger;y:integer);
var a,st:string;
begin
  st:='                    ';
  insert(s^.Reich,st,1);
  st:=copy(st,1,20);
  str(GetTruppenAnz(s,'Krieger'):6,a);
  st:=st+'|Kr:'+a;
  str(GetTruppenAnz(s,'Reiter'):6,a);
  st:=st+'|Re:'+a;
  str(GetTruppenAnz(s,'Schiffe'):6,a);
  st:=st+'|Sc:'+a;
  str(GetTruppenAnz(s,'Gefangen'):6,a);
  st:=st+'|Ge:'+a;
  str(GetTruppenAnz(s,'Sklaven'):8,a);
  st:=st+'|Sk:'+a;
  str(GetTruppenAnz(s,'Heerfhrer'):3,a);
  st:=st+'|Hf:'+a;
  outtextxy(5,y,st);
  st:=st+chr(13);st[255]:=chr(13);
  writeln(f,st);
  st:='                    ';
  str(GetTruppenAnz(s,'Geld'):6,a);
  st:=st+'|Ta:'+a;
  str(GetTruppenAnz(s,'Dorf'):6,a);
  st:=st+'|Do:'+a;
  str(GetTruppenAnz(s,'Stadt')+GetTruppenAnz(s,'Hauptstadt'):6,a);
  st:=st+'|St:'+a;
  str(GetTruppenAnz(s,'Handkart'):6,a);
  st:=st+'|Hk:'+a;
  str(GetTruppenAnz(s,'Mine'):2,a);
  st:=st+'|Mi:'+a;
  str(GetTruppenAnz(s,'Zauberer'):2,a);
  st:=st+'|Za:'+a;
  str(GetTruppenAnz(s,'Spion'):3,a);
  st:=st+'|Sp:'+a;
  outtextxy(5,y+15,st);
  st:=st+chr(13);st[255]:=chr(13);
  writeln(f,st);
  st:='                    ';
  str(GetTruppenAnz(s,'Feld'):6,a);
  st:=st+'|Bv:'+a;
  str(GetTruppenAnz(s,'Steuer'):6,a);
  st:=st+'|Ei:'+a;
  str(GetTruppenAnz(s,'Rstwert'):6,a);
  st:=st+'|R:'+a;
  str(GetTruppenAnz(s,'Kleinfel'):6,a);
  st:=st+'|KF:'+a;
  str(GetTruppenAnz(s,'MGS'):2,a); {Militrische Gesamtstrke}
  st:=st+'|GS:'+a;
  outtextxy(5,y+30,st);
  st:=st+chr(13);st[255]:=chr(13);
  writeln(f,st);
end;

procedure MinMaxStatistik;

function GetMaxTruppenAnz(ID:str8):longint;
var s:spielerlistzeiger;
    a,max:longint;
begin
  s:=spielerliste;max:=0;
  while s<>nil do
    begin                                      
      if (s^.reich<>'Piraten') and (s^.Reich<>'Non-Player-Char')
        then
          begin
            a:=GetTruppenAnz(s,ID);
            if a>max then max:=a;
          end;
      s:=s^.nxt;
    end;
  GetMaxTruppenAnz:=max;
end;

function GetMinTruppenAnz(ID:str8):longint;
var s:spielerlistzeiger;
    a,min:longint;

begin
  s:=spielerliste;min:=0;
  if s<>nil then
    begin
      min:=GetTruppenAnz(s,ID);
      s:=s^.nxt;
    end;
  while s<>nil do
    begin                                      
      if (s^.reich<>'Piraten') and (s^.Reich<>'Non-Player-Char')
        then
          begin
            a:=GetTruppenAnz(s,ID);
            if a<min then min:=a;
          end;
      s:=s^.nxt;
    end;
  GetMinTruppenAnz:=min;
end;

var a,st:string;
    Min,Max:longint;
begin
  st:='Maximum             ';
  str(GetMaxTruppenAnz('Krieger'):6,a);
  st:=st+'|Kr:'+a;
  str(GetMaxTruppenAnz('Reiter'):6,a);
  st:=st+'|Re:'+a;
  str(GetMaxTruppenAnz('Schiffe'):6,a);
  st:=st+'|Sc:'+a;
  str(GetMaxTruppenAnz('Gefangen'):6,a);
  st:=st+'|Ge:'+a;
  str(GetMaxTruppenAnz('Sklaven'):8,a);
  st:=st+'|Sk:'+a;
  str(GetMaxTruppenAnz('Heerfhrer'):3,a);
  st:=st+'|Hf:'+a;
  outtextxy(5,0,st);
  st:=st+chr(13);st[255]:=chr(13);
  writeln(f,st);
  st:='                    ';
  str(GetMaxTruppenAnz('Geld'):6,a);
  st:=st+'|Ta:'+a;
  str(GetMaxTruppenAnz('Dorf'):6,a);
  st:=st+'|Do:'+a;
  str(GetMaxTruppenAnz('Stadt')+GetMaxTruppenAnz('Hauptstadt'):6,a);
  st:=st+'|St:'+a;
  str(GetMaxTruppenAnz('Handkart'):6,a);
  st:=st+'|Hk:'+a;
  str(GetMaxTruppenAnz('Mine'):2,a);
  st:=st+'|Mi:'+a;
  str(GetMaxTruppenAnz('Zauberer'):2,a);
  st:=st+'|Za:'+a;
  str(GetMaxTruppenAnz('Spion'):3,a);
  st:=st+'|Sp:'+a;
  outtextxy(5,15,st);
  st:=st+chr(13);st[255]:=chr(13);
  writeln(f,st);
  st:='                    ';
  str(GetMaxTruppenAnz('Feld'):6,a);
  st:=st+'|Bv:'+a;
  str(GetMaxTruppenAnz('Steuer'):6,a);
  st:=st+'|Ei:'+a;
  str(GetMaxTruppenAnz('Rstwert'):6,a);
  st:=st+'|R:'+a;
  str(GetMaxTruppenAnz('Kleinfel'):6,a);
  st:=st+'|KF:'+a;
  str(GetMaxTruppenAnz('MGS'):2,a); {Militrische Gesamtstrke}
  st:=st+'|GS:'+a;
  outtextxy(5,30,st);
  st:=st+chr(13);st[255]:=chr(13);
  writeln(f,st);
  st:='Minimum             ';
  str(GetMinTruppenAnz('Krieger'):6,a);
  st:=st+'|Kr:'+a;
  str(GetMinTruppenAnz('Reiter'):6,a);
  st:=st+'|Re:'+a;
  str(GetMinTruppenAnz('Schiffe'):6,a);
  st:=st+'|Sc:'+a;
  str(GetMinTruppenAnz('Gefangen'):6,a);
  st:=st+'|Ge:'+a;
  str(GetMinTruppenAnz('Sklaven'):8,a);
  st:=st+'|Sk:'+a;
  str(GetMinTruppenAnz('Heerfhrer'):3,a);
  st:=st+'|Hf:'+a;
  outtextxy(5,45,st);
  st:=st+chr(13);st[255]:=chr(13);
  writeln(f,st);
  st:='                    ';
  str(GetMinTruppenAnz('Geld'):6,a);
  st:=st+'|Ta:'+a;
  str(GetMinTruppenAnz('Dorf'):6,a);
  st:=st+'|Do:'+a;
  str(GetMinTruppenAnz('Stadt')+GetMinTruppenAnz('Hauptstadt'):6,a);
  st:=st+'|St:'+a;
  str(GetMinTruppenAnz('Handkart'):6,a);
  st:=st+'|Hk:'+a;
  str(GetMinTruppenAnz('Mine'):2,a);
  st:=st+'|Mi:'+a;
  str(GetMinTruppenAnz('Zauberer'):2,a);
  st:=st+'|Za:'+a;
  str(GetMinTruppenAnz('Spion'):3,a);
  st:=st+'|Sp:'+a;
  outtextxy(5,60,st);
  st:=st+chr(13);st[255]:=chr(13);
  writeln(f,st);
  st:='                    ';
  str(GetMinTruppenAnz('Feld'):6,a);
  st:=st+'|Bv:'+a;
  str(GetMinTruppenAnz('Steuer'):6,a);
  st:=st+'|Ei:'+a;
  str(GetMinTruppenAnz('Rstwert'):6,a);
  st:=st+'|R:'+a;
  str(GetMinTruppenAnz('Kleinfel'):6,a);
  st:=st+'|KF:'+a;
  str(GetMinTruppenAnz('MGS'):2,a); {Militrische Gesamtstrke}
  st:=st+'|GS:'+a;
  outtextxy(5,75,st);
  st:=st+chr(13);st[255]:=chr(13);
  writeln(f,st);
end;

procedure RundenStatistik;
var s:spielerlistzeiger;
    a:integer;
begin
  assign(f,Path+'Statisti.txt');
  rewrite(f);
  cleardevice;SetColor(14);
  s:=spielerliste;a:=1;
  while s<>nil do
    begin
      SpielerStatistik(s,a*45);
      a:=a+1;s:=s^.nxt;
    end;
  pressreturn;
  cleardevice;
  MinMaxStatistik;
  close(f);
  pressreturn;
  cleardevice;
end;

procedure SpielerSpeicherDaten(sp:spielerlistzeiger;nam:string);
var p:dinglistzeiger;
    a:string[255];
    x,y:byte;
    f:text;

procedure DruckeINV(q:dingzeiger;presay:string);
var p:dinglistzeiger;
begin
  p:=q^.INV;
  while p<>nil do
    begin
      if (Reichsname(p^.ding^.besitz)=spieler^.reich) AND
         (IsID(p^.ding,'Truppe') or IsID(p^.ding,'Tragbar')) then
        begin
          write(f,presay:5,p^.ding^.name:15,'|');
          write(f,copy(feld[p^.ding^.ortx,p^.ding^.orty]^.name,1,10):10,'|');
          write(f,'Anz:',p^.ding^.anzahl:5,'|');
          write(f,GetTypName(p^.ding):15,'|');
          write(f,'Wert: ');
          if not IsID(p^.ding,'Person')
           then
             if IsID(p^.ding,'Schiffe')
               then
                 begin
                   write(f,'B:',p^.ding^.wert div 100);
                   write(f,' K:',(p^.ding^.wert div 10) mod 10);
                   writeln(f,' Z:',p^.ding^.wert mod 10);
                 end
               else
                 writeln(f,p^.ding^.wert)
           else writeln(f,'');
          DruckeINV(p^.ding,presay+'+');
        end;
      p:=p^.nxt;
    end;
end;

procedure DruckeHandkarten(var f:text;inv:dinglistzeiger;sp:spielerlistzeiger);
var p:dinglistzeiger;
    s:str20;
begin
  p:=inv;
  while p<>nil do
    begin
      if Reichsname(p^.ding^.besitz)=sp^.reich
        then
          if IsID(p^.ding,'Handkart')
            then
              begin
                str(p^.ding^.anzahl,s);
                writeln(f,GetID(p^.ding,1)+' ('+s+')');
              end
            else DruckeHandkarten(f,p^.ding^.inv,sp);
      p:=p^.nxt;
    end;
end;

begin
  assign(f,PATH+nam);
  rewrite(f);
  writeln(f,'Auswertung fuer '+sp^.reich);
  str(GetTruppenAnz(sp,'Geld'):6,a);
  writeln(f,'Reichsschatz:   '+a);
  {Handelskarten}
  writeln(f,'Du besitz folgende Handelskarten:');
  for x:=1 to MaxFeldX do
    for y:=1 to MaxFeldY do
        DruckeHandkarten(f,feld[x,y]^.INV,sp);
  writeln(f,'****************************************'+
            '****************************************');

  { Felder und Gebaeude }
  writeln(f,'Dein Reich besteht aus folgenden Feldern:');
  writeln(f,'');
  writeln(f,'Pos:':15,'|','Terrain':20,'|','Einwohner':15,'|',
            'Wert in Taler':15);
  for x:=1 to MaxFeldX do
    for y:=1 to MaxFeldY do
        if Reichsname(feld[x,y]^.besitz)=sp^.reich
          then
            begin
              write(f,feld[x,y]^.name:15);
              write(f,'|',TerrainName(feld[x,y]^.typ):20,'|');
              write(f,feld[x,y]^.anzahl:15,'|');
              writeln(f,(feld[x,y]^.anzahl div 20):15);
              p:=feld[x,y]^.INV;
              while p<>nil do
                begin
                  if IsID(p^.ding,'Gebude')
                    then
                      begin
                        write(f,p^.ding^.name:15);
                        write(f,'|',BauTypName(p^.ding^.typ):20,'|');
                        write(f,p^.ding^.anzahl:15,'|');
                        writeln(f,(p^.ding^.anzahl div 10):15);
                      end;
                  p:=p^.nxt;
                end;
            end;
  writeln(f,'');
  writeln(f,'Du hast folgende Truppen:');
  for x:=1 to MaxFeldX do
    for y:=1 to MaxFeldY do
      begin
        DruckeINV(feld[x,y],'');
      end;
  close(f);
end;

procedure Kaestchen(xx,yy,kzoom:integer;farbe:byte);
var a,b,c,x,y:integer;
begin
  x:=xx+1;y:=yy+1;
  if (xx mod 2)=0 then b:=kzoom div 2 else b:=0;
  c:=kzoom div 2;
  setcolor(farbe);
  for a:=1 to c do
   line((x-1)*kzoom+2 -(a div 2),(y-1)*kzoom+a+b,
            x*kzoom-2 +(a div 2),(y-1)*kzoom+a+b);
  for a:=c+1 to kzoom-1 do
   line((x-1)*kzoom+2 -((kzoom-a-1) div 2),(y-1)*kzoom+a+b,
            x*kzoom-2 +((kzoom-a-1) div 2),(y-1)*kzoom+a+b);
end;

procedure Umrandung(xx,yy,kzoom:integer;farbe:byte);
var b,c,x,y:integer;
begin
  x:=xx+1;y:=yy+1;
  if (xx mod 2)=0 then b:=kzoom div 2 else b:=0;
  c:=kzoom div 2;
  setcolor(farbe);
  line((x-1)*kzoom+2,(y-1)*kzoom+1+b,
           x*kzoom-2,(y-1)*kzoom+1+b);
  line((x-1)*kzoom+2,(y-1)*kzoom+2+b,
           x*kzoom-2,(y-1)*kzoom+2+b);
  line((x-1)*kzoom+3,y*kzoom-1+b,
           x*kzoom-3,y*kzoom-1+b);
  line((x-1)*kzoom+3,y*kzoom-2+b,
           x*kzoom-3,y*kzoom-2+b);

  line((x-1)*kzoom+2 -(c div 2),(y-1)*kzoom+c+b,
       (x-1)*kzoom+2,(y-1)*kzoom+1+b);
  line((x-1)*kzoom+2 -(c div 2),(y-1)*kzoom+c+b,
       (x-1)*kzoom+3,y*kzoom-1+b);
  line(1+(x-1)*kzoom+2 -(c div 2),(y-1)*kzoom+c+b,
       1+(x-1)*kzoom+2,(y-1)*kzoom+1+b);
  line(1+(x-1)*kzoom+2 -(c div 2),(y-1)*kzoom+c+b,
       1+(x-1)*kzoom+3,y*kzoom-1+b);

  line(x*kzoom-2               ,(y-1)*kzoom+1+b,
       x*kzoom-2 +(c div 2)    ,(y-1)*kzoom+c+b);
  line(x*kzoom-3               ,y*kzoom-1+b,
       x*kzoom-2 +(c div 2)    ,(y-1)*kzoom+c+b);
  line(x*kzoom-2-1             ,(y-1)*kzoom+1+b,
       x*kzoom-2 +(c div 2)-1  ,(y-1)*kzoom+c+b);
  line(x*kzoom-3-1             ,y*kzoom-1+b,
       x*kzoom-2 +(c div 2)-1  ,(y-1)*kzoom+c+b);
end;

procedure MalAufbaute(Ding:DingZeiger;kzoom:integer);
var a,b,c,x,y:integer;
    d:char;
    q:DingZeiger;
begin
  x:=Ding^.ortx+1;y:=Ding^.orty+1;
  if (Ding^.ortx mod 2)=0 then b:=kzoom div 2 else b:=0;
  q:=IsGetarnt(ding);
if IsID(q,'Truppe') then
  begin
    d:=' ';
    case q^.typ of
      1 : d:='H';
      2 : d:='K';
      3 : d:='R';
      4 : d:='S';
      5 : d:='A';
      6 : d:='P';
      7 : d:='G';
      8 : d:='E';
      9 : d:='H';
     10 : d:='H';
     11 : d:='H';
     12 : d:='H';
     13 : d:='H';
    end;
    setcolor(15);
    for a:=(kzoom div 4)-1 to (kzoom div 2)+(kzoom div 4) do
      line((x-1)*kzoom+2 ,(y-1)*kzoom+a+b,
               x*kzoom-4 ,(y-1)*kzoom+a+b);
    setcolor(q^.besitz);
    if d<>' ' then outtextXY((x-1)*kzoom+(kzoom div 4),
                             (y-1)*kzoom+b+(kzoom div 4),d);
  end;
if IsID(q,'Gebude') then
  case q^.typ of
   1 :begin
        setcolor(0);
        for a:=(kzoom div 4) to (kzoom div 2)+(kzoom div 4) do
          line((x-1)*kzoom+4 ,(y-1)*kzoom+a+b,
                   x*kzoom-4 ,(y-1)*kzoom+a+b);
        setcolor(15);
        a:=kzoom div 4;
        line((x-1)*kzoom+4 ,(y-1)*kzoom+a+b,x*kzoom-4 ,(y-1)*kzoom+a+b);
        c:=(kzoom div 2)+(kzoom div 4);
        line((x-1)*kzoom+4 ,(y-1)*kzoom+c+b,x*kzoom-4 ,(y-1)*kzoom+c+b);
        line((x-1)*kzoom+4 ,(y-1)*kzoom+a+b,(x-1)*kzoom+4 ,(y-1)*kzoom+c+b);
        line(x*kzoom-4 ,(y-1)*kzoom+a+b,x*kzoom-4 ,(y-1)*kzoom+c+b);
      end;
   2 :begin
        setcolor(4);
        for a:=(kzoom div 4) to (kzoom div 2)+(kzoom div 4) do
          line((x-1)*kzoom+4 ,(y-1)*kzoom+a+b,
                   x*kzoom-4 ,(y-1)*kzoom+a+b);
        setcolor(0);
        a:=kzoom div 4;
        line((x-1)*kzoom+4 ,(y-1)*kzoom+a+b,x*kzoom-4 ,(y-1)*kzoom+a+b);
        c:=(kzoom div 2)+(kzoom div 4);
        line((x-1)*kzoom+4 ,(y-1)*kzoom+c+b,x*kzoom-4 ,(y-1)*kzoom+c+b);
        line((x-1)*kzoom+4 ,(y-1)*kzoom+a+b,(x-1)*kzoom+4 ,(y-1)*kzoom+c+b);
        line(x*kzoom-4 ,(y-1)*kzoom+a+b,x*kzoom-4 ,(y-1)*kzoom+c+b);
      end;
   3 :begin
        setcolor(4);
        for a:=1 to (kzoom div 4) do
          circle((x-1)*kzoom+4+(kzoom div 4), (y-1)*kzoom+b+(kzoom div 2),a);
        setcolor(0);
        a:=kzoom div 4;
        circle((x-1)*kzoom+4+(kzoom div 4), (y-1)*kzoom+b+(kzoom div 2),a);
      end;
   4 :begin
        setcolor(0);
        for a:=1 to (kzoom div 4) do
          circle((x-1)*kzoom+4+(kzoom div 4), (y-1)*kzoom+b+(kzoom div 2),a);
        setcolor(15);
        a:=kzoom div 4;
        circle((x-1)*kzoom+4+(kzoom div 4), (y-1)*kzoom+b+(kzoom div 2),a);
      end;
  end;
end;

procedure NeuerSpieler;
var q:SpielerListZeiger;
    s:str20;
begin
  cleargraf;
  Grafausgabe(1,'Neuen Spieler hinzufgen');
  Grafausgabe(2,'Name>');
  readstrXY(45,getmaxY-115+15*2,s);
  if s<>'' then
    begin
      if Spielerliste=nil
        then
          begin
            new(Spielerliste);
            q:=spielerliste;
          end
        else
          begin
            q:=Spielerliste;
            while q^.nxt<>nil do q:=q^.nxt;
            new(q^.nxt);
            q:=q^.nxt;
          end;
      q^.name:=s;
      q^.nxt:=nil;
      Grafausgabe(3,'Reich>');
      readstrXY(55,getmaxY-115+15*3,q^.reich);
      FeldReset(q^.feld);
    end;
end;


function NeuesDing:dingzeiger;
var q:dingzeiger;
    wahl,typ:integer;
begin
  q:=nil;
  clearGraf;
  GrafAusgabe(1,'Was soll hinzugefgt werden?');
  GrafAusgabe(2,'1-Aufbauten  2-Armee  3-Geld  4-Handelskarte 5-Tarnung');
  GrafAusgabe(3,'6-Benutzer definiertes');
  GrafAusgabe(7,'>');
  readnrXY(10,getmaxY-115+15*7,wahl);
  case wahl of
   1 : begin
         clearGraf;
         GrafAusgabe(1,'Was soll hinzugefgt werden?');
         GrafAusgabe(2,'1-Haupstadt  2-Stadt  3-Dorf  4-Burg  '
                      +'5-Dipi-Schule  6-Forschungsinstitut');
         GrafAusgabe(7,'>');
         readnrXY(10,getmaxY-115+15*7,typ);
         if (typ>0) and (typ<=BauTypMax) then
           begin
             new(q);
             Dinginit(q);
             q^.typ:=typ;
             AddID(q,BauTypName(typ));
             AddID(q,'Gebude');
          end;
       end;
   2 : begin
         clearGraf;
         GrafAusgabe(1,'Was soll hinzugefgt werden?');
         GrafAusgabe(2,'1-Herrscher 2-Krieger  3-Reiter  4-Schiffe  5-Sklaven  6-Pferde  7-Gefangene');
         GrafAusgabe(3,'8-Siedler 9-Heerfhrer  10-Zauberer  11-Spion  12-Diplomat  13-Archeologe');
         GrafAusgabe(7,'>');
         readnrXY(10,getmaxY-115+15*7,typ);
         if (typ>0) and (typ<=TruppTypMax) then
           begin
             new(q);
             Dinginit(q);
             q^.typ:=typ;
             AddID(q,TruppTypName(typ));
             case typ of
               1,9,10,11,12,13: AddID(q,'Person');
             end;
             AddID(q,'Truppe');
           end;
       end;
   3 : begin
         new(q);
         Dinginit(q);
         q^.typ:=0;
         AddID(q,'Geld');
         AddID(q,'Tragbar'); {Wert von Geld=10*Gewicht pro Stueck}
         q^.wert:=1;
       end;
   4 : begin
         clearGraf;
         GrafAusgabe(1,'Handelskarte Typ-Nr?');
         GrafAusgabe(3,'>');
         readnrXY(14,getmaxY-115+15*3,typ);
         if (typ>0) and (typ<=HandkTypMax) then
           begin
             new(q);
             Dinginit(q);
             q^.typ:=typ;
             AddID(q,HandkTypName(typ));
             AddID(q,'Handkarte');
             AddID(q,'Tragbar');
             q^.wert:=HandkTypWert(typ);
             q^.anzahl:=1;
           end;
       end;
   5 : begin
         new(q);
         Dinginit(q);
         AddID(q,'Tarnung');
         AddID(q,'Hidden');
       end;
   6 : begin
         new(q);
         Dinginit(q);
         AddID(q,'Wahlding');
       end;
  end;
  NeuesDing:=q;
end;

procedure DingDaten(ding:dingzeiger);
var s,t:string;
    p:dinglistzeiger;
    q:dingzeiger;
begin
  q:=IsGetarnt(ding);
  GrafAusgabe(1,'1) Name : '+q^.name+
                '    2) Pos : '+Notation(ding^.ortx,ding^.orty)+
                '    4) Besitz :'+Reichsname(q^.besitz));
  p:=ding^.inv;s:='';
  while p<>nil do
    begin
      str(IsGetarnt(p^.ding)^.anzahl,t);
      s:=s+GetTypName(p^.Ding)+'('+t+'),';
      p:=p^.nxt;
    end;
  GrafAusgabe(2,'3) Inhalt      : '+copy(s,1,61));
  if length(s)>61
    then
      GrafAusgabe(3,'               : '+copy(s,62,61))
    else
      GrafAusgabe(3,' ');
  if length(s)>122
    then
      GrafAusgabe(4,'               : '+copy(s,123,61))
    else
      GrafAusgabe(4,' ');
  str(MaxAvail,s);str(MemAvail,t);
  GrafAusgabe(5,'5) Typ         : '+GetTypName(ding)+
                '          Max/Mem:'+s+'/'+t);
  str(q^.anzahl:5,s);
  str(q^.wert:5,t);
  GrafAusgabe(6,'6) Anz/Wert (7): '+s+'/'+t);
end;

function GetRelX(a:integer):integer;
var x:integer;
begin
  x:=0;
  case a of
   1,2,3,4                 : x:=a-1;
   5,6,7,8,9               : x:=a-6;
   10,11,12,13,14,15       : x:=a-12;
   16,17,18,19,20,21,22    : x:=a-19;
   23,24,25,26,27,28,29,30 : x:=a-27;
   31,32,33,34,35,36,37    : x:=a-35;
   38,39,40,41,42,43       : x:=a-42;
   44,45,46,47,48          : x:=a-48;
  end;
  GetRelX:=x;
end;

function GetRelY(a:integer):integer;
var y:integer;
begin
  y:=0;
  case a of
   1                       : y:=0;
   2,3,5,6,10              : y:=1;
   23,16,17,11,12,7,8,4    : y:=2;
   31,24,25,18,19,13,14,9  : y:=3;
   38,32,33,26,27,20,21,15 : y:=4;
   44,39,40,34,35,28,29,22 : y:=5;
   45,46,41,42,36,37,30    : y:=6;
   47,48,43                : y:=7;
  end;
  GetRelY:=y;
end;

function IntToStr(a:integer):string;
var s:string;
begin
  str(a,s);
  if a div 10=0
    then IntToStr:='0'+s
    else IntToStr:=s;
end;

procedure NummGrossfeld(x,y:integer;name:string;feld:FeldTyp);
var nam:string;
    a:integer;
begin
  nam:=name;
  for a:=1 to 48 do
    if (x+GetRelX(a)>0) and (x+GetRelX(a)<=MaxFeldX) and
       (y+GetRelY(a)<=MaxFeldY) and (y+GetRelY(a)>0) then
           feld[x+GetRelX(a),y+GetRelY(a)]^.name:=nam+'.'+IntToStr(a);
end;

procedure MakePopulation(feld:feldtyp);
var a,b:byte;
    c:integer;
begin
  for a:=1 to MaxFeldX do
    for b:=1 to MaxFeldY do
      if feld[a,b]^.anzahl=0 then
        feld[a,b]^.anzahl:=(20+Random(81))*(MaxTerrainBev(feld[a,b]^.typ) div 100);
end;

procedure SetzeOrte(dlst:dinglistzeiger;x,y:byte);
var p:dinglistzeiger;
begin
  p:=dlst;
  while p<>nil do
   begin
     p^.ding^.ortx:=x;
     p^.ding^.orty:=y;
     SetzeOrte(p^.ding^.inv,x,y);
     p:=p^.nxt;
   end;
end;

procedure EditObjekt(ding:dingzeiger;var c:char;feld:FeldTyp);
var a,code:integer;
    x,y:byte;
    s:string;
    newid:str20;
    s8:str8;
    p:DingListZeiger;
    d:dingzeiger;
    Befehl:char;
begin
   case c of
     '1' : begin
             GrafAusgabe(1,'1) Name    >');
             ReadStrXY(12*8+8,getmaxY-115+15*1,ding^.name);
             val(ding^.name,a,code);
             if (ding^.env=nil) and (a<>0) and (code=0)
               then NummGrossfeld(ding^.ortx,ding^.orty,ding^.name,feld);
           end;
     '2' : if ding^.env<>nil
            then
              begin
                GrafAusgabe(2,'2) Neue Position (0..6) >');
                ReadNrXY(8*25+8,getmaxY-115+15*2,a);
                x:=xNachbar(ding^.ortx,ding^.orty,a);
                y:=yNachbar(ding^.ortx,ding^.orty,a);
                if a>0 then
                  begin
                    If (x=0) or (y=0)
                      then
                        begin
                          GrafAusgabe(3,'Bitte auf dem Spielfeld bleiben.');
                          pressreturn;
                        end
                      else
                        begin
                          SubInv(ding^.env,ding);
                          AddInv(feld[x,y],ding);
                          ding^.ortx:=x;
                          ding^.orty:=y;
                          SetzeOrte(ding^.inv,x,y);
                          ding^.env:=feld[x,y];
                        end;
                  end;
              end
            else
              begin
                GrafAusgabe(2,'2) Das Feld bleibt wo es ist!');
                pressreturn;
              end;
     '3' : begin
             GrafAusgabe(4,'Edit Nummer>');
             ReadNrXY(12*8+8,getmaxY-115+15*4,a);
             a:=a-1;
             p:=ding^.inv;
             while (a>0) and (p<>nil) do
               begin
                 a:=a-1;p:=p^.nxt;
               end;
             if p<>nil then
               begin
                 repeat
                    DingDaten(p^.ding);
                    befehl:=upcase(readkey);
                    EditObjekt(p^.ding,befehl,feld);
                 until (befehl=chr(13)) or (befehl=chr(27));
               end;
           end;
     '4' : begin
             GrafAusgabe(4,'4) Besitz  >');
             ReadNrXY(12*8+8,getmaxY-115+15*4,a);
             ding^.besitz:=a;
           end;
     '5' : begin
             GrafAusgabe(5,'5) Typ     >');
             ReadNrXY(12*8+8,getmaxY-115+15*5,a);
             ding^.typ:=a;
           end;
     '6' : begin
             GrafAusgabe(6,'6) Anzahl  >');
             ReadNrXY(12*8+8,getmaxY-115+15*6,ding^.anzahl);
           end;
     '7' : begin
             GrafAusgabe(6,'7) Wert    >');
             ReadNrXY(12*8+8,getmaxY-115+15*6,ding^.wert);
           end;
     '8' : begin
             ClearGraf;
             GrafAusgabe(2,'1 - ID vorne hinzufgen');
             GrafAusgabe(3,'2 - ID hinten hinzufgen');
             GrafAusgabe(5,'Nr.    >');
             ReadNrXY(12*8+8,getmaxY-115+15*5,a);
             if (a=1) or (a=2) then
               begin
                 GrafAusgabe(5,'Neue ID>');
                 ReadStrXY(12*8+8,getmaxY-115+15*5,newid);
                 s8:=newid;
                 case a of
                  1: p^.ding^.ID:=MakeIDList(newid+'|'+IDString(p^.ding^.ID));
                  2: p^.ding^.ID:=MakeIDList(IDString(p^.ding^.ID)+newid+'|');
                 end;
               end;
             pressreturn;
           end;
     '9' : begin
             d:=NeuesDing;
             if d<>nil then
               begin
                 AddINV(ding,d);
                 d^.env:=ding;
                 d^.ortx:=ding^.ortx;
                 d^.orty:=ding^.orty;
                 d^.besitz:=ding^.besitz;
               end;
           end;
     '@' : begin
             if ding^.env=nil
               then GrafAusgabe(7,'*** Objekt unzerstrbar ***')
               else
                 begin
                   SubINV(ding^.env,ding);
                   Dingdone(ding);
                   dispose(ding);
                   GrafAusgabe(7,'*** Objekt zerstrt ***');
                 end;
             pressreturn;
             c:=chr(13);
           end;
   end;
end;

procedure ZeigeTopoKarte(kzoom:integer;feld:FeldTyp);
var x,y:integer;
    p:DingListZeiger;
begin
  for x:=1 to MaxFeldx do
    for y:=1 to MaxFeldy do
      begin
        Kaestchen(x,y,kzoom,ffarbeMitte(feld[x,y]^.typ));
        Umrandung(x,y,kzoom,ffarbeRand(feld[x,y]^.typ));
        p:=feld[x,y]^.inv;
        while p<>nil do
          begin
            MalAufbaute(p^.Ding,kzoom);
            p:=p^.nxt;
          end;
      end;
end;

function EditTopoKarte(kzoom:integer;feld:FeldTyp):char;
var x,y,a:integer;
    s:string;
    c:char;
    flag:boolean;
    p:DingListZeiger;
begin
  x:=21;y:=12;
  repeat
    Kaestchen(x,y,kzoom,15);
    DingDaten(feld[x,y]);
    c:=upcase(readkey);
    if ord(c)=0 then begin c:=upcase(readkey);flag:=TRUE;end
                else flag:=false;
    Kaestchen(x,y,kzoom,ffarbeMitte(feld[x,y]^.typ));
    Umrandung(x,y,kzoom,ffarbeRand(feld[x,y]^.typ));
    p:=feld[x,y]^.inv;
    while p<>nil do
       begin
         {if p^.Ding^.IsID('Gebude') then} MalAufbaute(p^.Ding,kzoom);
         p:=p^.nxt;
       end;
    case c of
     'H': if (y>1) and flag then y:=y-1;
     'P': if (y<MaxFeldy) and flag then y:=y+1;
     'K': if (x>1) and flag then x:=x-1;
     'M': if (x<MaxFeldx) and flag then x:=x+1;
     '&': MakePopulation(feld);
     '!': SpielerSpeicherDaten(spieler,spieler^.Reich+'.TXT');
     '*':begin
           feld[x,y]^.typ:=feld[x,y]^.typ+1;
           if feld[x,y]^.typ>15 then feld[x,y]^.typ:=0;
         end;
     '$': NeuerSpieler;
     'R': begin
            RundenStatistik;
            ZeigeTopoKarte(kzoom,feld);
          end;
     '?': begin
            GrafAusgabe(6,'Aktiver Spieler>');
            ReadNrXY(16*8+8,getmaxY-115+15*6,a);
            spieler:=SpielerZeiger(a);
            if spieler^.feld[1,1]=nil
              then feldReset(spieler^.feld);
          end;
    end;
  EditObjekt(feld[x,y],c,feld);
  if c='2' then ZeigeTopoKarte(kzoom,feld);
  until ((c='P') and not flag) or (c=chr(27)) or (c='\') or (c='S')
         or (c='L') or (c='C');
  EditTopoKarte:=c;
end;

procedure Sicht(feld,spielerfeld:feldtyp;x,y,hoehe:byte);
var a,b,c:byte;
begin
  for a:=1 to 6 do
    if (XNachbar(x,y,a)>0) and (XNachbar(x,y,a)<=MaxFeldX) and
       (YNachbar(x,y,a)>0) and (YNachbar(x,y,a)<=MaxFeldY)
      then
        begin
          b:=XNachbar(x,y,a);c:=YNachbar(x,y,a);
          if Stufe(feld[b,c]^.typ)<=hoehe
            then CopyDing(feld[b,c],spielerfeld[b,c],nil,2);
          if (Stufe(feld[b,c]^.typ)>hoehe) and
             (spielerfeld[b,c]^.typ=0)
            then CopyDing(feld[b,c],spielerfeld[b,c],nil,1);
          if Stufe(feld[b,c]^.typ)<hoehe
            then Sicht(feld,spielerfeld,b,c,hoehe-1);
        end;
end;

function CopyMode(kzoom:integer;sfeld,feld,spielerfeld:FeldTyp):char;
var x,y:integer;
    s:string;
    c:char;
    flag:boolean;
    p:DingListZeiger;
    a:byte;
begin
  x:=21;y:=12;
  repeat
    Kaestchen(x,y,kzoom,15);
    DingDaten(feld[x,y]);
    GrafAusgabe(6,'Copy-Mode: Master -> '+spieler^.Reich);
    GrafAusgabe(7,'Feld kopieren mit <Return>');
    c:=upcase(readkey);
    if ord(c)=0 then begin c:=upcase(readkey);flag:=TRUE;end
                else flag:=false;
    Kaestchen(x,y,kzoom,ffarbeMitte(sfeld[x,y]^.typ));
    Umrandung(x,y,kzoom,ffarbeRand(sfeld[x,y]^.typ));
    p:=sfeld[x,y]^.inv;
    while p<>nil do
       begin
         {if p^.Ding^.IsID('Gebude') then} MalAufbaute(p^.Ding,kzoom);
         p:=p^.nxt;
       end;
    case c of
     'H': if (y>1) and flag then y:=y-1;
     'P': if (y<MaxFeldy) and flag then y:=y+1;
     'K': if (x>1) and flag then x:=x-1;
     'M': if (x<MaxFeldx) and flag then x:=x+1;
    end;
    if c=chr(13) then
      begin
        DingDone(spielerfeld[x,y]);
        dispose(spielerfeld[x,y]);
        new(spielerfeld[x,y]);
        Dinginit(Spielerfeld[x,y]);
        CopyAlles(feld[x,y],spielerfeld[x,y],nil);
        Sicht(feld,spielerfeld,x,y,Stufe(feld[x,y]^.typ));
      end;
    if c='F' then
      begin
        DingDone(spielerfeld[x,y]);
        dispose(spielerfeld[x,y]);
        new(spielerfeld[x,y]);
        Dinginit(Spielerfeld[x,y]);
        CopyAlles(feld[x,y],spielerfeld[x,y],nil);
      end;
  until ((c='P') and not flag) or (c=chr(27)) or (c='\') or (c='S')
         or (c='T');
  CopyMode:=c;
end;

procedure ZeigePolitKarte(kzoom:integer;feld:FeldTyp);
var x,y:integer;
    p:DingListZeiger;
begin
  for x:=1 to MaxFeldx do
    for y:=1 to MaxFeldy do
      begin
        if feld[x,y]^.typ>1
         then
          if feld[x,y]^.Besitz=0 then Kaestchen(x,y,kzoom,15)
                                 else Kaestchen(x,y,kzoom,feld[x,y]^.Besitz)
         else Kaestchen(x,y,kzoom,0);
        p:=feld[x,y]^.inv;
        while p<>nil do
          begin
            MalAufbaute(p^.Ding,kzoom);
            p:=p^.nxt;
          end;
      end;
end;

function EditPolitKarte(kzoom:integer;feld:FeldTyp):char;
var a,x,y:integer;
    s:string;
    c:char;
    flag:boolean;
    p:DingListZeiger;
begin
  x:=21;y:=12;
  repeat
    Kaestchen(x,y,kzoom,14);
    DingDaten(feld[x,y]);
    c:=upcase(readkey);
    if feld[x,y]^.typ>1
      then
        if feld[x,y]^.Besitz=0 then Kaestchen(x,y,kzoom,15)
                               else Kaestchen(x,y,kzoom,feld[x,y]^.Besitz)
      else Kaestchen(x,y,kzoom,0);
    if ord(c)=0 then begin c:=upcase(readkey);flag:=TRUE;end
                else flag:=false;
    p:=feld[x,y]^.inv;
    while p<>nil do
       begin
         MalAufbaute(p^.Ding,kzoom);
         p:=p^.nxt;
       end;
    case c of
     'H': if (y>1) and flag then y:=y-1;
     'P': if (y<MaxFeldy) and flag then y:=y+1;
     'K': if (x>1) and flag then x:=x-1;
     'M': if (x<MaxFeldx) and flag then x:=x+1;
     '*':begin
           feld[x,y]^.typ:=feld[x,y]^.typ+1;
           if feld[x,y]^.typ>15 then feld[x,y]^.typ:=0;
         end;
     '$': NeuerSpieler;
     'R': begin
            RundenStatistik;
            ZeigeTopoKarte(kzoom,feld);
          end;
     '?': begin
            GrafAusgabe(6,'Aktiver Spieler>');
            ReadNrXY(16*8+8,getmaxY-115+15*6,a);
            spieler:=SpielerZeiger(a);
            if spieler^.feld[1,1]=nil
              then feldReset(spieler^.feld);
          end;
    end;
  EditObjekt(feld[x,y],c,feld);
  if c='2' then ZeigePolitKarte(kzoom,feld);
  until ((c='T') and not flag) or (c=chr(27)) or (c='\') or (c='S')
        or (c='L') or (c='C');
  EditPolitKarte:=c;
end;

function MaxZugWeite(o:Dingzeiger):byte;
var max,a:byte;
      p:Dingzeiger;
      q:DinglistZeiger;
begin
  max:=0;a:=0;
  p:=o;
  If (IsID(p,'Truppe'))
    then
      begin
        if IsID(p,'Krieger') then max:=1;
        if IsID(p,'Reiter') then max:=2;
        if IsID(p,'Person') then max:=3;
        if IsID(p,'Sklaven') then max:=1;
        if IsID(p,'Gefangen') then max:=1;
        if IsID(p,'Siedler') then max:=1;
        if IsID(p,'Pferde') then max:=2;
        if IsID(p,'Schiffe') then max:=p^.wert div 100;
      end;
  q:=p^.INV;
  while q<>nil do
    begin
      a:=MaxZugWeite(q^.ding);
      if a>max then max:=a;
      q:=q^.nxt;
    end;
  MaxZugWeite:=max;
end;

procedure Zuganalyse;
var x,y:integer;
    a,b,max:byte;
    s:string;
begin
  max:=0;cleardevice;setcolor(14);
  for x:=1 to MaxFeldX do
    for y:=1 to MaxFeldY do
      begin
        a:=MaxZugWeite(feld[x,y]);
        if a>max then max:=a;
      end;
  str(max,s);
  outtextxy(5,5,'Schnellste Truppe: '+s+' Felder');
end;

begin
  initgrafik;
  Initialisierung;
  repeat
    c:='T';spieleran:=false;
    repeat
      if (c<>'T') and (c<>'P') and (c<>'\') and (c<>chr(27))
         and (c<>'S') and (c<>'C') and (c<>'L')
        then
          begin
            c:='T';
            write(chr(7));
          end;
      case c of
        'T':if Spieleran
              then
                begin
                  ZeigeTopoKarte(14,Spieler^.feld);
                   c:=EditTopoKarte(14,Spieler^.feld);
                end
              else
                begin
                  ZeigeTopoKarte(14,feld);
                   c:=EditTopoKarte(14,feld);
                end;
        'C':if spielerAn
              then
                begin
                  ZeigeTopoKarte(14,spieler^.feld);
                  c:=CopyMode(14,Spieler^.feld,feld,Spieler^.feld);
                end
              else
                 begin
                   ZeigeTopoKarte(14,feld);
                   c:=CopyMode(14,feld,feld,Spieler^.feld);
                 end;
        'P':if Spieleran
              then
                begin
                  ZeigePolitKarte(14,Spieler^.feld);
                   c:=EditPolitKarte(14,Spieler^.feld);
                end
              else
                begin
                  ZeigePolitKarte(14,feld);
                   c:=EditPolitKarte(14,feld);
                end;
        'L':begin
              c:='T';
              If spieleran
                then
                  ObjekteLaden(spieler^.reich,spieler^.feld)
                else
                  begin
                    ObjekteLaden('AUCObjek',feld);
                    Grafausgabe(1,'Objekte geladen');
                    SpielerLaden;
                    Grafausgabe(2,'Spieler geladen');
                  end;
            end;
        '\':begin
              c:='T';
              If spieleran
                then
                  ObjekteSpeichern(spieler^.reich,spieler^.feld)
                else
                  begin
                    ObjekteSpeichern('AUCObjek',feld);
                    SpielerSpeichern;
                  end;
            end;
        'S': if Spieler<>nil
               then
                 begin
                   SpielerAn:=not SpielerAn;
                   c:='T';
                 end
               else
                 begin
                   SpielerAn:=False;
                   c:='T';
                 end;
      end;
    until c=chr(27);
    c:=readkey;
  until c='J';
  textmode(c80);
end.


{ Liste der implementierten Aufbauten:
  Typ 1: Hauptstadt        = schwarzes Quadrat;
      2: Stadt             = rotes Quadrat;
      3: Dorf              = roter Kreis;
      4: Burg              = schwarzer Kreis;
      5: Dipi-Schule       = n.a.
      6: Forschungsinstitut= n.a.

  Liste der implementierten Truppen:
  Typ 1: Herrscher    = H
      2: Krieger      = K
      3: Reiter       = R
      4: Schiffe      = S
      5: Sklaven      = A
      6: Pferde       = P
      7: Gefangene    = G
      8: Siedler      = E
      9: Heerfhrer   = H
     10: Zauberer     = H
     11: Spion        = H

  Liste der implementierten Mobilien:
   Geld       : Wert=10
   Handkarten
     Typ Kategorie  Name     (Last-)Wert
      1      1      Ocker       3000
      2             Felle
      3             Baumwolle
      4             Roggen
      5             Fische
      6             Kse
      7             Krbe
      8      2      Schurwolle  2700
      9             Bier
     10             Wein
     11             Weizen
     12             Kohle
     13             Mehl
     14             Leinen
     15      3      l          2400
     16             Honig
     17             Wachs
     18             Leder
     19             Obst
     20             Tuch
     21      4      Kleidung    2100
     22             Spiritus
     23             Zucker
     24             Tee
     25             Kunst
     26      5      Teppiche    1800
     27             Salz
     28             Kaffee
     29             Spitzen
     30      6      Porzellan   1500
     31             Seide
     32             Farben
     33      7      Instrumente 1200
     34             Rauschgift
     35      8      Gewrze      900
     36      9      Schmuck      600
}